//
//  CMFLACEnc.m
//  CMFLACPlugin
//
//  Created by tmkk on Sat Jul 17 2004.
//  Copyright (c) 2004 tmkk. All rights reserved.
//

#import "CMFLACEnc.h"


@implementation CMFLACEnc

- (id) initWithFile: (char *)file
{
	[super init];
	flacEncoder = FLAC__file_encoder_new();
	FLAC__file_encoder_set_filename(flacEncoder, file);
	return self;
}

- (int)setChannel: (int)ch frequency:(int)freq bytes: (int)n dataSize: (int)size compressionLevel:(int)c
{
	channels = ch;
	bytesPerChannel = n;
	
	FLAC__file_encoder_set_channels(flacEncoder, (unsigned)ch);
	FLAC__file_encoder_set_bits_per_sample(flacEncoder, (unsigned)n*8);
	FLAC__file_encoder_set_sample_rate(flacEncoder, (unsigned)freq);
	FLAC__file_encoder_set_total_samples_estimate(flacEncoder, size/n);
	padding.is_last = false; /* the encoder will set this for us */
	padding.type = FLAC__METADATA_TYPE_PADDING;
	padding.length = 4096;
	metadata[0] = &padding;
	FLAC__file_encoder_set_metadata(flacEncoder, metadata, 1);
	
	switch(c) {
	  case 0:
		FLAC__file_encoder_set_blocksize(flacEncoder, 1152);
		FLAC__file_encoder_set_max_lpc_order(flacEncoder, 0);
		FLAC__file_encoder_set_min_residual_partition_order(flacEncoder, 2);
		FLAC__file_encoder_set_max_residual_partition_order(flacEncoder, 2);
		break;
	  case 1:
		FLAC__file_encoder_set_blocksize(flacEncoder, 1152);
		FLAC__file_encoder_set_max_lpc_order(flacEncoder, 0);
		FLAC__file_encoder_set_do_mid_side_stereo(flacEncoder, true);
		FLAC__file_encoder_set_loose_mid_side_stereo(flacEncoder, true);
		FLAC__file_encoder_set_min_residual_partition_order(flacEncoder, 2);
		FLAC__file_encoder_set_max_residual_partition_order(flacEncoder, 2);
		break;
	  case 2:
		FLAC__file_encoder_set_blocksize(flacEncoder, 1152);
		FLAC__file_encoder_set_max_lpc_order(flacEncoder, 0);
		FLAC__file_encoder_set_do_mid_side_stereo(flacEncoder, true);
		FLAC__file_encoder_set_min_residual_partition_order(flacEncoder, 0);
		FLAC__file_encoder_set_max_residual_partition_order(flacEncoder, 3);
		break;
	  case 3:
		FLAC__file_encoder_set_blocksize(flacEncoder, 4608);
		FLAC__file_encoder_set_max_lpc_order(flacEncoder, 6);
		FLAC__file_encoder_set_min_residual_partition_order(flacEncoder, 3);
		FLAC__file_encoder_set_max_residual_partition_order(flacEncoder, 3);
		break;
	  case 4:
		FLAC__file_encoder_set_blocksize(flacEncoder, 4608);
		FLAC__file_encoder_set_max_lpc_order(flacEncoder, 8);
		FLAC__file_encoder_set_do_mid_side_stereo(flacEncoder, true);
		FLAC__file_encoder_set_loose_mid_side_stereo(flacEncoder, true);
		FLAC__file_encoder_set_min_residual_partition_order(flacEncoder, 3);
		FLAC__file_encoder_set_max_residual_partition_order(flacEncoder, 3);
		break;
	  case 5:
		FLAC__file_encoder_set_blocksize(flacEncoder, 4608);
		FLAC__file_encoder_set_max_lpc_order(flacEncoder, 8);
		FLAC__file_encoder_set_do_mid_side_stereo(flacEncoder, true);
		FLAC__file_encoder_set_min_residual_partition_order(flacEncoder, 3);
		FLAC__file_encoder_set_max_residual_partition_order(flacEncoder, 3);
		break;
	  case 6:
		FLAC__file_encoder_set_blocksize(flacEncoder, 4608);
		FLAC__file_encoder_set_max_lpc_order(flacEncoder, 8);
		FLAC__file_encoder_set_do_mid_side_stereo(flacEncoder, true);
		FLAC__file_encoder_set_min_residual_partition_order(flacEncoder, 0);
		FLAC__file_encoder_set_max_residual_partition_order(flacEncoder, 4);
		break;
	  case 7:
		FLAC__file_encoder_set_blocksize(flacEncoder, 4608);
		FLAC__file_encoder_set_max_lpc_order(flacEncoder, 8);
		FLAC__file_encoder_set_do_mid_side_stereo(flacEncoder, true);
		FLAC__file_encoder_set_min_residual_partition_order(flacEncoder, 0);
		FLAC__file_encoder_set_max_residual_partition_order(flacEncoder, 6);
		FLAC__file_encoder_set_do_exhaustive_model_search(flacEncoder, true);
		break;
	  case 8:
		FLAC__file_encoder_set_blocksize(flacEncoder, 4608);
		FLAC__file_encoder_set_max_lpc_order(flacEncoder, 12);
		FLAC__file_encoder_set_do_mid_side_stereo(flacEncoder, true);
		FLAC__file_encoder_set_min_residual_partition_order(flacEncoder, 0);
		FLAC__file_encoder_set_max_residual_partition_order(flacEncoder, 6);
		FLAC__file_encoder_set_do_exhaustive_model_search(flacEncoder, true);
		break;
	}
	if(ch == 1) {
		FLAC__file_encoder_set_do_mid_side_stereo(flacEncoder, false);
		FLAC__file_encoder_set_loose_mid_side_stereo(flacEncoder, false);
	}
	
	int ret = FLAC__file_encoder_init(flacEncoder);
	if(ret) return 1;
	
	return 0;
}

- (int)setBufferSize: (int)size
{

	if((buffer_converted[0] = (int *)malloc(size*4/bytesPerChannel/channels))==NULL){
		return 1;
	}
	if(channels == 2) {
		if((buffer_converted[1] = (int *)malloc(size*4/bytesPerChannel/channels))==NULL){
			return 1;
		}
	}
	return 0;
}

- (int)encodeBuffer: (char *)buffer blockNum:(int)nblock
{
	int i;
	unsigned char *ptr1 = (unsigned char *)buffer;
	short *ptr2 = (short *)buffer;
	int sample, wide_sample, channel, byte;
	
	switch(bytesPerChannel) {
		case 1:
			for(sample = wide_sample = 0; wide_sample < nblock; wide_sample++)
				for(channel = 0; channel < channels; channel++, sample++) 
					buffer_converted[channel][wide_sample] = (FLAC__int32)ptr1[sample] - 0x80;
			break;
		case 2:
			for(sample = wide_sample = 0; wide_sample < nblock; wide_sample++)
				for(channel = 0; channel < channels; channel++, sample++)
					buffer_converted[channel][wide_sample] = (FLAC__int32)ptr2[sample];
			break;
		case 3:
			for(byte = sample = wide_sample = 0; wide_sample < nblock; wide_sample++)
				for(channel = 0; channel < channels; channel++, sample++) {
#ifdef _BIG_ENDIAN
					buffer_converted[channel][wide_sample]  = buffer[byte++];
					buffer_converted[channel][wide_sample] <<= 8;
					buffer_converted[channel][wide_sample] |= ptr1[byte++];
					buffer_converted[channel][wide_sample] <<= 8;
					buffer_converted[channel][wide_sample] |= ptr1[byte++];
#else
					buffer_converted[channel][wide_sample]  = buffer[byte+2];
					buffer_converted[channel][wide_sample] <<= 8;
					buffer_converted[channel][wide_sample] |= ptr1[byte+1];
					buffer_converted[channel][wide_sample] <<= 8;
					buffer_converted[channel][wide_sample] |= ptr1[byte];
					byte += 3;
#endif
				}
			break;
	}
	
	FLAC__bool ret = FLAC__file_encoder_process(flacEncoder, (int **)buffer_converted, nblock);
	if(!ret) return 1;
	
	return 0;
}

- (void)finish
{
	FLAC__file_encoder_finish(flacEncoder);
}

- (void)dealloc
{
	free(buffer_converted[0]);
	if(channels == 2) free(buffer_converted[1]);
	if(flacEncoder) FLAC__file_encoder_delete(flacEncoder);
	[super dealloc];
}

@end
